#include <PA9.h>         // include de las PAlib 

#include "gfx/all_gfx.c" // include del PAGfxConverter ( sprite )
#include "gfx/all_gfx.h"

typedef struct{
	int x, y; // posicin
	int ax, ay;	//final position
} palito;
palito pala1[2];
palito pala2[2];

typedef struct{
		u8 speed;
		int xp, yp; //posicion *10
        int x, y; //posicin
        int xd, yd; //desplazamiento
} bolita;
bolita bola[2];

typedef struct{
        int contador, tiempo;
        s8 perder;
		s16 punt1, punt2;
		s16 separacion[2];
		s16 col_cont;
		s16 col_act;
} data;
data datos;

typedef struct{
        s8 screen;
} maquina;
maquina AI;

typedef struct{
        s8 item[2];		//object to use[player]
		s8 uitem[2];	//object used[player]
		s16 counter[2];	//counter of used item
		s16 nextitem[2];	//next item counter
		s8 ion[2];	//sprite del item enseado :?
} objetos;
objetos items;

void Mover_Bola(u8 i);
void Jugar();
void Reset();
void Pause();
void AI_CPU();
void Use_Item(u8 a);
void Item_counter();
void Item_Effects();
void Remove_Items();
void Show_Item();
void Colision(u8 i);
void Col_Bordes(int px, int py, int a, u8 i, u8 c);
void Actualiza_Pantalla();

int main(void)	{
	
	PA_Init();
	PA_InitVBL();
	PA_InitRand();
	PA_InitText(0,2);
	PA_SetTextTileCol(0,2);
	
	datos.punt1=0;
	datos.punt2=0;
	datos.perder=0;

//Items-
//0=nada
//1=Mover palas (2segundos)


	bola[0].xd=-1;
	bola[0].yd=1;
	bola[1].yd=1;
	
	u8 i=0;
	for(i=0;i<2;i++){
		pala1[i].x=0;
		pala1[i].y=78;
		pala2[i].x=256;
		pala2[i].y=78;
		bola[i].xp=1240;
		bola[i].yp=700;
		bola[i].speed=10;
		items.item[i]=0;
		items.uitem[i]=0;
		items.nextitem[i]=0;
		items.counter[i]=0;
	}
	
	// palos
	PA_LoadSpritePal(0,0,(void*)sprite0_Pal); 
	PA_CreateSprite(0,0,(void*)pala_Sprite,OBJ_SIZE_16X32,1,0,pala1[0].x,pala1[0].y);
	PA_CreateSprite(0,1,(void*)pala_Sprite,OBJ_SIZE_16X32,1,0,pala2[0].x,pala2[0].y);
	PA_SetSpritePrio(0,0,1);
	PA_SetSpritePrio(0,1,1);
	
	PA_LoadSpritePal(1,0,(void*)sprite0_Pal); 
	PA_CreateSprite(1,0,(void*)pala_Sprite,OBJ_SIZE_16X32,1,0,pala1[1].x,pala1[1].y);
	PA_CreateSprite(1,1,(void*)pala_Sprite,OBJ_SIZE_16X32,1,0,pala2[1].x,pala2[1].y);
	PA_SetSpritePrio(1,0,1);
	PA_SetSpritePrio(1,1,1);
	
	// Bola
	PA_LoadSpritePal(0,1,(void*)sprite1_Pal);
	PA_LoadSpritePal(0,2,(void*)sprite2_Pal);
	PA_LoadSpritePal(0,3,(void*)sprite3_Pal);
	PA_CreateSprite(0,2,(void*)bola_Sprite,OBJ_SIZE_8X8,1,1,bola[0].x,bola[0].y);
	PA_CreateSprite(0,3,(void*)bola2_Sprite,OBJ_SIZE_8X8,1,2,bola[0].x,bola[0].y);
	PA_CreateSprite(0,4,(void*)bola3_Sprite,OBJ_SIZE_8X8,1,3,bola[0].x,bola[0].y);
	PA_SetSpritePrio(0,2,1);
	PA_SetSpritePrio(0,3,1);
	PA_SetSpritePrio(0,4,1);
	
	PA_LoadSpritePal(1,1,(void*)sprite1_Pal);
	PA_LoadSpritePal(1,2,(void*)sprite2_Pal);
	PA_LoadSpritePal(1,3,(void*)sprite3_Pal);
	PA_CreateSprite(1,2,(void*)bola_Sprite,OBJ_SIZE_8X8,1,1,bola[1].x,bola[1].y);
	PA_CreateSprite(1,3,(void*)bola2_Sprite,OBJ_SIZE_8X8,1,2,bola[1].x,bola[1].y);
	PA_CreateSprite(1,4,(void*)bola3_Sprite,OBJ_SIZE_8X8,1,3,bola[1].x,bola[1].y);
	PA_SetSpritePrio(1,2,1);
	PA_SetSpritePrio(1,3,1);
	PA_SetSpritePrio(1,4,1);
	
//sprites:
//0 = P1 pala
//1 = P2 pala
//2 = bola
//3 = sombra bola 1
//4 = sombra bola 2
//5 = Item P1
//6 = Item P2

//paletas de colores:
//0 = palas
//1 = bola
//2 = sombra bola 1
//3 = sombra bola 2
//4 = Item P1
//5 = Item P2

	//Fondo
	PA_LoadPal(PAL_BG0, bg_Pal);
	PA_LoadSimpleBg(0,3, bg_Tiles, bg_Map, BG_256X256,0,1);
	
	PA_OutputText(0,13,2,"%d - %d", datos.punt1, datos.punt2);
	Reset();	//valores iniciales al empezar una partida
	while(1){
		Jugar();	//ir jugando
		Reset();	//cuando ya no puedes jugar, k se prepare para resetear
	}
	
	return 0;
}

void Actualiza_Pantalla(){
	u8 a=0;
	for(a=0;a<2;a++){
		pala1[a].ax=pala1[a].x+datos.separacion[0];
		pala1[a].ay=pala1[a].y;
		pala2[a].ax=pala2[a].x-datos.separacion[1]-13;
		pala2[a].ay=pala2[a].y;
		
		PA_SetSpriteXY(a,0,pala1[a].ax,pala1[a].ay);
		PA_SetSpriteXY(a,1,pala2[a].ax,pala2[a].ay);
		PA_SetSpriteXY(a,2,bola[a].x,bola[a].y);
		PA_SetSpriteXY(a,3,(bola[a].x-(bola[a].xd*3)),(bola[a].y-(bola[a].yd*3)));
		PA_SetSpriteXY(a,4,(bola[a].x-(bola[a].xd*6)),(bola[a].y-(bola[a].yd*6)));
	}
	PA_OutputText(0,1,1,"Tiempo: %d", (datos.tiempo/60));
		
	//mostrar items
	if(items.item[0]==0)PA_SetSpriteXY(0,5,0,192);
	if(items.item[1]==0)PA_SetSpriteXY(0,6,232,192);
}
void Jugar(){
	datos.perder=0;
	while(datos.perder==0)
	{
		//debug
		//PA_OutputText(0,4,5,"%d  . %d  . %d  . %d  ", bola[0].speed, items.item[0], items.uitem[0], items.ion[0]);	
		//PA_OutputText(0,4,6,"%d  . %d  . %d  . %d  ", bola[1].speed, items.item[1], items.uitem[1], items.ion[1]);
		Mover_Bola(0);
		Mover_Bola(1);
		AI_CPU();
		
		if(Pad.Newpress.L==1)Use_Item(0);
		Item_counter();
		Item_Effects();
		
		//contador y dems
		datos.contador++;
		datos.tiempo++;
		if(datos.contador==50)
		{
		datos.separacion[0]++;
		datos.separacion[1]++;
		datos.contador=0;
		}	
		Actualiza_Pantalla();
		PA_WaitForVBL();
		if(Pad.Newpress.Start==1)Pause();
	}
}

void Mover_Bola(u8 i){
	//mover tu pala
	if(pala1[i].y>0){
	pala1[i].y -= Pad.Held.Up;
	if(Pad.Held.B)pala1[i].y -= Pad.Held.Up;
	}
	if(pala1[i].y<159){
	pala1[i].y += Pad.Held.Down;
	if(Pad.Held.B)pala1[i].y += Pad.Held.Down;
	}
	
	Colision(i);//colision
	
	//mover bola
	
	bola[i].xp+=bola[i].xd*bola[i].speed;
	bola[i].yp+=bola[i].yd*bola[i].speed;
	
	bola[i].x=bola[i].xp/10;
	bola[i].y=bola[i].yp/10;
	
	Colision(i);//colision
}

void Colision(u8 i){
	u8 d;
	//colision de los lados (arriba y abajo)
	if(datos.col_act==0)datos.col_cont++;
	if(datos.col_cont==50)datos.col_act=1;
	if(datos.col_act==1)
	{
		if(bola[i].yd==1)
		{
		Col_Bordes(pala1[i].ax, pala1[i].ay,-8, i, 0);
		Col_Bordes(pala2[i].ax, pala2[i].ay,-8, i, 1);
		}
		else if(bola[i].yd==-1){
		Col_Bordes(pala1[i].ax, pala1[i].ay, 32, i, 0);
		Col_Bordes(pala2[i].ax, pala2[i].ay, 32, i, 1);
		}
	}
	
	//colision lateral
	for(d=0;d<2;d++){
		if((bola[i].x+d)<1)datos.perder=1;
		if((bola[i].x+d)==(pala1[i].ax+13))if(bola[i].y>(pala1[i].ay-8))if(bola[i].y<(pala1[i].ay+32))bola[i].xd=1;
		
		if((bola[i].x+8-d)==pala2[i].ax)if(bola[i].y>(pala2[i].ay-8))if(bola[i].y<(pala2[i].ay+32))bola[i].xd=-1;
		if((bola[i].x-d)>248)datos.perder=2;
		
		if(bola[i].y==0)bola[i].yd=1;
		if(bola[i].y>184)bola[i].yd=-1;
	}
}

void Col_Bordes(int px, int py, int a, u8 i, u8 c){
	u8 d;
	u16 b = datos.separacion[i];
	if(c==1)b*=-1;

	for(d=0;d<3;d++){
		if(bola[i].y==(py+a))if((bola[i].x+d)>(px-15))if((bola[i].x-16+d)<px){
			bola[i].yd*=-1;
			datos.col_cont=0;
			datos.col_act=0;
		}
	}
}

void Pause(){
	u16 contador=0;
	PA_OutputText(0,10,10,"Juego Pausado");
	while(Pad.Released.Start==0){
		PA_WaitForVBL();
	}
	while(Pad.Newpress.Start==0){
		if(contador==60)PA_OutputText(0,10,10,"             ");
		else if(contador==120){
		PA_OutputText(0,10,10,"Juego Pausado");
		contador=0;
		}
		contador++;
		PA_WaitForVBL();
	}
	PA_OutputText(0,10,10,"             ");
}

void Reset(){
	u8 i=0;
	if(datos.perder==2)datos.punt1++;
	if(datos.perder==1)datos.punt2++;
	for(i=0;i<2;i++){
	pala1[i].x=0;
	pala1[i].y=78;
	pala2[i].x=256;
	pala2[i].y=78;
	bola[i].xp=1240;
	bola[i].yp=700;
	bola[i].x=124;
	bola[i].y=70;
	bola[i].speed=10;
	items.counter[i]=1;
	}
	
	bola[1].xd=bola[0].xd*(-1);
	datos.separacion[0]=20;
	datos.separacion[1]=20;
	datos.perder=0;
	datos.contador=0;
	datos.col_cont=0;
	datos.col_act=0;
	
	PA_OutputText(0,3,10,"Pulsa Start para empezar");
	PA_OutputText(0,13,2,"%d - %d", datos.punt1, datos.punt2);
	
	Actualiza_Pantalla();
	
	while(Pad.Newpress.Start==0){
	PA_WaitForVBL();
	}
	
	PA_OutputText(0,1,1,"Tiempo:                            ");
	PA_OutputText(0,3,10,"                        ");
	datos.tiempo=0;
	//poner pantalla en la k la CPU ta mirando
	if(bola[1].xd==-1)
	{
		if(bola[0].xd==-1)
		{
			if(bola[0].x<bola[1].x)AI.screen=0;
			else AI.screen=1;
		}
		else AI.screen=0;
	}
	else {
		if(bola[0].xd==1)
		{
			if(bola[0].x>bola[1].x)AI.screen=0;
			else AI.screen=1;
		}
		else AI.screen=1;
	}
}
#include "includes/items.c"
#include "includes/ai.c"
